#!/usr/bin/env python
# -*- coding: utf-8 -*-

import re

from SePL.execute import Execute

class ProxTocol:
	
	def __init__(self):
		#~ Variable pour les fichiers
		self.InFile = False;
		self.DATA = None;
		self.Files = [];
		#~ Variable pour les paquets
		self.PackageInstall = [];
		self.PackageRemove = [];
		#~ Var pour les dépôts
		self.ReposAdd = [];
	
	def Parse(self, Request):
		#~ Boucle pour parser toutes les lignes de la requête
		for Line in Request.splitlines():
			#~ Si paquet
			if re.search("^(Package-Install|Package-Remove):: ", Line):
				self._FileParse();
				self._PackageParse(Line);
			#~ Si dépot
			elif re.search("^Repos-Add:: ", Line):
				self._FileParse();
				self._ReposParse(Line);
			#~ 
			#~ PLACER ICI LES AUTRES REGEX
			#~ 
			#~ Si Fichier
			elif re.search("^File-Create:: ", Line):
				self._FileParse();
				self.InFile = True;
				self.DATA = Line;
			#~ Si contenu de fichier
			elif self.InFile == True:
				self.DATA = self.DATA + "\n" + Line;
				pass
			#~ Sinon on fait rien
			else:
				pass
		self._Execute();
	
	def _FileParse(self):
		if self.InFile == True:
			File = [];
			File.append(re.split("^File-Create:: (.*)\n", self.DATA)[1]);
			File.append(re.split("^File-Create:: (.*)\n", self.DATA)[2]);
			self.Files.append(File);
			#~ Remet les var
			self.InFile = False;
			self.DATA = "";
		return True;
	
	def _PackageParse(self, Line):
		Package = re.split(":: |;", Line);
		if Package[0] == "Package-Install":
			for Pkg in Package:
				if Pkg != "Package-Install":
					self.PackageInstall.append(Pkg);
		elif Package[0] == "Package-Remove":
			for Pkg in Package:
				if Pkg != "Package-Remove":
					self.PackageRemove.append(Pkg);
		return True;
	
	def _ReposParse(self, Line):
		Repos = re.split(":: |;", Line);
		self.ReposAdd.append(Repos[1]);
		return True;
	
	def _Execute(self):
		#~ print "REPOS ADD :"
		#~ print self.ReposAdd
		#~ print "PKG INSTALL :"
		#~ print self.PackageInstall;
		#~ print "PKG REMOVE :"
		#~ print self.PackageRemove;
		#~ print "FILE CREATE :"
		#~ print self.Files;
		Ex = Execute();
		Ex.Files(self.Files);
